package sample.rule;

import org.rule.IRule;
import org.rule.parameter.RuleResult;
import org.rule.parameter.PlainParam;

/**
 * ̓oCgTCY`FbNs
 * initValueɂ͐li[Ă
 * optionlŕAoCg؂蕪
 * default̓oCg`FbN
 * F"STR"
 * oCgF"BYTE"
 *
 */
public class CheckLength implements IRule {

    private String initValue = null;
    private String optionParam = null;

    /**
     * ȏ̏s
     */
    public void initRule(String initVal, String optionParam) {
        this.initValue = initVal;
        this.optionParam = optionParam;
    }


    public RuleResult executeRule(PlainParam plainParam) {
        RuleResult ruleResult = null;
        String value = null;

        try {
            value = (String)plainParam.getParam();

            if (this.optionParam == null) {

                ruleResult = this.checkByte(value);
            } else if(this.optionParam.equals("BYTE")) {

                ruleResult = this.checkByte(value);
            } else if(this.optionParam.equals("STR")) {

                ruleResult = this.checkStr(value);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ruleResult;
    }

    /**
     * oCg̒`FbN
     */
    public RuleResult checkByte(String value) throws Exception {
        RuleResult ruleResult = new RuleResult();
        try {

            ruleResult.setName("CheckLength - Byte");

            if (value != null) {
                if (value.getBytes().length > Integer.parseInt(this.initValue)) {
                    // G[
                    ruleResult.setErrorFlg(true);
                    ruleResult.setErrorMessage(this.initValue + "oCgI[o[Ă܂");
                } else {
                    // 
                    ruleResult.setErrorFlg(false);
                }
            }
        } catch (Exception e) {
            throw e;
        }
        return ruleResult;
    }


    /**
     * `FbN
     */
    public RuleResult checkStr(String value) throws Exception {
        RuleResult ruleResult = new RuleResult();
        try {

            ruleResult.setName("CheckLength - Str");

            if (value != null) {
                if (value.length() > Integer.parseInt(this.initValue)) {
                    // G[
                    ruleResult.setErrorFlg(true);
                    ruleResult.setErrorMessage(this.initValue + "I[o[Ă܂");
                } else {
                    // 
                    ruleResult.setErrorFlg(false);
                }
            }
        } catch (Exception e) {
            throw e;
        }
        return ruleResult;
    }

}