package org.rule.parameter.config;

import java.util.ArrayList;


/** 
 * ̃[Ώ(ݒt@Cattribute̋؂P)Pʂł̃[ێ
 * [͕`ôŁAMɕ̏ێ
 * gp@́Anext\bgĂяoĂA[NX̖OAoB
 * ŏIl܂łƁAfalseԂ
 * 
 * @author T.Okuyama
 */
public class RuleConfigMap {

    private ArrayList ruleClassNameList = null;

    private ArrayList ruleClassParamList = null;

    private ArrayList ruleClassOptionList = null;

    private int nowIndex = -1;

    // Ώۑ
    private String targetAttributeName = null;

    // Ώۑ̔z
    private String[] targetAttributeNames = null;

    // ̑ɂ܂ݒ肩̃tO
    private boolean multiAttribute = false;

    /**
     * RXgN^
     */
    public RuleConfigMap() {
        this.ruleClassNameList = new ArrayList();
        this.ruleClassParamList = new ArrayList();
        this.ruleClassOptionList = new ArrayList();
    }

    /**
     * [NX̖OƁAli[
     */
    public void addRuleDetail(String ruleClassName, String ruleInitParam, String ruleOption) {
        this.ruleClassNameList.add(ruleClassName);
        this.ruleClassParamList.add(ruleInitParam);
        this.ruleClassOptionList.add(ruleOption);
    }

    /**
     * [NX̖OƁAlԂɎo
     * java.sql.ResultSet݂Ȏg
     */
    public boolean next() {
        boolean ret = false;

        this.nowIndex++;
        if (this.ruleClassNameList.size() > nowIndex) {
            ret = true;
        }
        return ret;
    }

    /**
     * next()\bgĂяoɌĂяô{
     * ݃tH[JXĂ郋[NX̖Oo
     */
    public String getRuleClassName() throws Exception {
        String className = null;
        try {
            if (this.nowIndex == -1 ||  this.nowIndex >= this.ruleClassNameList.size()) 
                throw new Exception("łɃ[Xg̃TCY𒴂Ă܂B");

            className = (String)this.ruleClassNameList.get(this.nowIndex);
        } catch (Exception e) {
            throw e;
        }
        return className;
    }

    /**
     * next()\bgĂяoɌĂяô{
     * ݃tH[JXĂ郋[NX̏lo
     */
    public String getRuleClassInitParam() throws Exception {
        String initParam = null;
        try {
            if (this.nowIndex == -1 ||  this.nowIndex >= this.ruleClassParamList.size()) 
                throw new Exception("łɃ[Xg̃TCY𒴂Ă܂B");

            initParam = (String)this.ruleClassParamList.get(this.nowIndex);
        } catch (Exception e) {
            throw e;
        }
        return initParam;
    }

    /**
     * next()\bgĂяoɌĂяô{
     * ݃tH[JXĂ郋[NXOptionlo
     */
    public String getRuleClassOptionParam() throws Exception {
        String optionParam = null;
        try {
            if (this.nowIndex == -1 ||  this.nowIndex >= this.ruleClassOptionList.size()) 
                throw new Exception("łɃ[Xg̃TCY𒴂Ă܂B");

            optionParam = (String)this.ruleClassOptionList.get(this.nowIndex);
        } catch (Exception e) {
            throw e;
        }
        return optionParam;
    }


    /**
     * gێ郋[KΏۂ̐ݒ葮ݒ肷
     *
     * @param targetAttributeName Ώۂ̐ݒ葮
     */
    public void  setTargetAttributeName(String targetAttributeName) {
        this.targetAttributeName = targetAttributeName;
        this.targetAttributeNames = new String[] {targetAttributeName};
    }

    /**
     * gێ郋[KΏۂ̐ݒ葮Qݒ肷
     *
     * @param targetAttributeNames Ώۂ̐ݒ葮
     */
    public void setTargetAttributeNames(String[] targetAttributeNames) {
        this.targetAttributeNames = targetAttributeNames;
    }

    /**
     * gێ郋[KΏۂ̐ݒ葮Ԃ
     * 1\Ԃ
     *
     * @return String Ώۂ̐ݒ葮
     */
    public String getTargetAttributeName() {
        return this.targetAttributeName;
    }

    /**
     * gێ郋[KΏۂ̐ݒ葮Ԃ
     * \AԂ
     *
     * @return String[] Ώۂ̐ݒ葮̔z
     */
    public String[] getTargetAttributeNames() {
        return this.targetAttributeNames;
    }

    /**
     * ̑ɂ܂ݒ肩Zbg
     */
    public void setMultiAttribute(boolean flg) {
        this.multiAttribute = flg;
    }

    /**
     * ̑ɂ܂ݒ肩擾
     */
    public boolean isMultiAttribute() {
        return this.multiAttribute;
    }

    /**
     * g̃ANZXCfbNX̏ꏊɖ߂
     */
    public void initNext() {
        this.nowIndex = -1;
    }
}

